## ocaml-ctypes 0.2.3

=== Makefile ===
.SECONDEXPANSION:

OCAML=ocaml
OCAMLDEP=ocamldep
OCAMLFIND=ocamlfind
OCAMLMKLIB=ocamlmklib
VPATH=src examples
BUILDDIR=_build
PROJECTS=configure configured ctypes ctypes-foreign-base ctypes-foreign-threaded ctypes-foreign-unthreaded ctypes-top
GENERATED=src/ctypes_config.h src/ctypes_config.ml setup.data src/ctypes/ctypes_primitives.ml
CFLAGS=-fPIC -Wall -O3 $(OCAML_FFI_INCOPTS)
OCAML_FFI_INCOPTS=$(libffi_opt)

# public targets
all: setup.data build

build: $(PROJECTS)

clean:
	rm -fr _build

distclean: clean
	rm -f $(GENERATED)

# ctypes subproject
ctypes.public = unsigned signed structs ctypes posixTypes
ctypes.dir = src/ctypes
ctypes.extra_mls = ctypes_primitives.ml
ctypes.deps = bigarray
ctypes.install = yes
ctypes.install_native_objects = yes

ctypes: PROJECT=ctypes
ctypes: $(ctypes.dir)/$(ctypes.extra_mls) $$(LIB_TARGETS)

# ctypes-foreign-base subproject
ctypes-foreign-base.public = dl
ctypes-foreign-base.install = yes
ctypes-foreign-base.install_native_objects = yes
ctypes-foreign-base.threads = no
ctypes-foreign-base.dir = src/ctypes-foreign-base
ctypes-foreign-base.subproject_deps = ctypes
ctypes-foreign-base.link_flags = $(libffi_lib)
ctypes-foreign-base.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-base.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)

ctypes-foreign-base: PROJECT=ctypes-foreign-base
ctypes-foreign-base: $$(LIB_TARGETS)

# ctypes-foreign-threaded subproject
ctypes-foreign-threaded.public = foreign
ctypes-foreign-threaded.install = yes
ctypes-foreign-threaded.threads = yes
ctypes-foreign-threaded.dir = src/ctypes-foreign-threaded
ctypes-foreign-threaded.subproject_deps = ctypes ctypes-foreign-base
ctypes-foreign-threaded.link_flags = $(libffi_lib)
ctypes-foreign-threaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-threaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-threaded.install_native_objects = no

ctypes-foreign-threaded: PROJECT=ctypes-foreign-threaded
ctypes-foreign-threaded: $$(LIB_TARGETS)

# ctypes-foreign-unthreaded subproject
ctypes-foreign-unthreaded.public = foreign
ctypes-foreign-unthreaded.install = yes
ctypes-foreign-unthreaded.threads = no
ctypes-foreign-unthreaded.dir = src/ctypes-foreign-unthreaded
ctypes-foreign-unthreaded.subproject_deps = ctypes ctypes-foreign-base
ctypes-foreign-unthreaded.link_flags = $(libffi_lib)
ctypes-foreign-unthreaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-unthreaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-threaded.install_native_objects = no

ctypes-foreign-unthreaded: PROJECT=ctypes-foreign-unthreaded
ctypes-foreign-unthreaded: $$(LIB_TARGETS)

# ctypes-top subproject
ctypes-top.public = ctypes_printers
ctypes-top.dir = src/ctypes-top
ctypes-top.install = yes
ctypes-top.deps = compiler-libs
ctypes-top.subproject_deps = ctypes
ctypes-top.install_native_objects = yes

ctypes-top: PROJECT=ctypes-top
ctypes-top: $$(LIB_TARGETS)

# configure subproject
configure.dir = src/configure

configure: PROJECT=configure
configure: $$(NATIVE_TARGET)

# configuration
configured: src/ctypes/ctypes_primitives.ml

src/ctypes/ctypes_primitives.ml: $(BUILDDIR)/configure.native
	$< > $@

setup.data: src/discover/discover.ml
	ocaml $^ -ocamlc "$(OCAMLFIND) ocamlc"

# dependencies
depend: configure
	$(OCAMLDEP) $(foreach project,$(PROJECTS),-I $($(project).dir)) \
             src/*/*.mli src/*/*.ml examples/*/*.mli examples/*/*.ml \
           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" > .depend

#installation
META-install:
	$(OCAMLFIND) install ctypes META

install-%: PROJECT=$*
install-%:
	$(if $(filter yes,$($(PROJECT).install)),\
		$(OCAMLFIND) install -add ctypes $^ \
                   $(LIB_TARGETS) $(LIB_TARGET_EXTRAS) \
                   $(INSTALL_MLIS) $(INSTALL_CMIS) \
                   $(if $(filter yes,$($(PROJECT).install_native_objects)),$(NATIVE_OBJECTS)))

install: META-install $(PROJECTS:%=install-%)

uninstall:
	$(OCAMLFIND) remove ctypes

.PHONY: depend distclean clean build configure all install $(PROJECTS)

include .depend Makefile.rules Makefile.examples Makefile.tests
-include setup.data

=== debian/changelog ===
ocaml-ctypes (0.2.3-1build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 04 Nov 2015 11:41:24 -0600

ocaml-ctypes (0.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #742613)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 25 Mar 2014 15:47:23 +0100

=== debian/control ===
Source: ocaml-ctypes
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 9),
 libffi-dev,
 libounit-ocaml-dev,
 ocaml-findlib,
 ocaml-nox (>= 4.00.0),
 dh-ocaml
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-ctypes.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-ctypes.git
Homepage: https://github.com/ocamllabs/ocaml-ctypes

Package: libctypes-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: library for binding to C libraries using pure OCaml (runtime)
 The ocaml-ctypes library makes it possible to call C functions
 directly from OCaml without writing or generating C code.  The core
 of the library is a set of combinators for describing C types --
 scalars, functions, structs, unions, arrays, and pointers to values
 and functions.  Type descriptions can then be used to bind native
 functions and values.
 .
 This package contains the shared runtime stub library and plugins.

Package: libctypes-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: library for binding to C libraries using pure OCaml (dev)
 The ocaml-ctypes library makes it possible to call C functions
 directly from OCaml without writing or generating C code.  The core
 of the library is a set of combinators for describing C types --
 scalars, functions, structs, unions, arrays, and pointers to values
 and functions.  Type descriptions can then be used to bind native
 functions and values.
 .
 This package contains all the development stuff you need to use
 ocaml-ctypes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DESTDIR := $(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
OCAMLFIND_LDCONF=ignore

export OCAMLFIND_DESTDIR
export OCAMLFIND_LDCONF

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(DESTDIR)/$(OCAML_DLL_DIR)
	dh_auto_install

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing -X.so.owner

=== debian/watch ===
version=3
https://github.com/ocamllabs/ocaml-ctypes/releases/ocaml-ctypes-(.*)\.tar\.gz

## ocaml-ctypes 0.7.0

=== Makefile ===
.SECONDEXPANSION:

BEST:=$(shell if ocamlopt > /dev/null 2>&1; then echo native; else echo byte; fi)
DEBUG=false
COVERAGE=false
OCAML=ocaml
OCAMLFIND=ocamlfind
HOSTOCAMLFIND=$(OCAMLFIND)
OCAMLDEP=$(OCAMLFIND) ocamldep
OCAMLMKLIB=$(OCAMLFIND) ocamlmklib
VPATH=src examples
BUILDDIR=_build
BASE_PROJECTS=configure libffi-abigen configured ctypes ctypes-top
FOREIGN_PROJECTS=test-libffi ctypes-foreign-base ctypes-foreign-threaded ctypes-foreign-unthreaded
STUB_PROJECTS=cstubs
PROJECTS=$(BASE_PROJECTS) $(FOREIGN_PROJECTS) $(STUB_PROJECTS)
GENERATED=src/ctypes/ctypes_primitives.ml	\
          src/ctypes-foreign-base/libffi_abi.ml \
          src/ctypes-foreign-base/dl.ml		\
          src/ctypes-foreign-base/dl_stubs.c	\
          libffi.config				\
          asneeded.config
OCAML_FFI_INCOPTS=$(libffi_opt)
export CFLAGS DEBUG

EXTDLL:=$(shell $(OCAMLFIND) ocamlc -config | awk '/^ext_dll:/{print $$2}')
OSYSTEM:=$(shell $(OCAMLFIND) ocamlc -config | awk '/^system:/{print $$2}')

ifneq (,$(filter mingw%,$(OSYSTEM)))
OS_ALT_SUFFIX=.win
else
OS_ALT_SUFFIX=.unix
endif

# public targets
all: libffi.config $(PROJECTS)

ctypes-base: $(BASE_PROJECTS)
ctypes-foreign: ctypes-base $(FOREIGN_PROJECTS)
ctypes-stubs: ctypes-base $(STUB_PROJECTS)

clean:
	rm -fr _build
	rm -f $(GENERATED)

# ctypes subproject
ctypes.public = ctypes_static ctypes_primitive_types unsigned signed ctypes_structs ctypes posixTypes ctypes_types
ctypes.dir = src/ctypes
ctypes.extra_mls = ctypes_primitives.ml
ctypes.deps = str bigarray bytes
ctypes.install = yes
ctypes.install_native_objects = yes
ifeq ($(XEN),enable)
ctypes.xen = yes
endif

ctypes: PROJECT=ctypes
ctypes: $(ctypes.dir)/$(ctypes.extra_mls) $$(LIB_TARGETS)

# cstubs subproject
cstubs.public = cstubs_internals cstubs_structs cstubs cstubs_inverted
cstubs.dir = src/cstubs
cstubs.subproject_deps = ctypes
cstubs.deps = str bytes
cstubs.install = yes

cstubs: PROJECT=cstubs
cstubs: $(cstubs.dir)/$(cstubs.extra_mls) $$(LIB_TARGETS)

# ctypes-foreign-base subproject
ctypes-foreign-base.public = dl libffi_abi
ctypes-foreign-base.install = yes
ctypes-foreign-base.install_native_objects = yes
ctypes-foreign-base.threads = no
ctypes-foreign-base.dir = src/ctypes-foreign-base
ctypes-foreign-base.deps = bytes
ctypes-foreign-base.subproject_deps = ctypes
ctypes-foreign-base.extra_mls = libffi_abi.ml dl.ml
ctypes-foreign-base.extra_cs = dl_stubs.c
ctypes-foreign-base.link_flags = $(libffi_lib) $(lib_process)
ctypes-foreign-base.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-base.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)

ctypes-foreign-base: PROJECT=ctypes-foreign-base
ctypes-foreign-base: $$(LIB_TARGETS)

# ctypes-foreign-threaded subproject
ctypes-foreign-threaded.public = foreign
ctypes-foreign-threaded.install = yes
ctypes-foreign-threaded.threads = yes
ctypes-foreign-threaded.dir = src/ctypes-foreign-threaded
ctypes-foreign-threaded.subproject_deps = ctypes ctypes-foreign-base
ctypes-foreign-threaded.link_flags = $(libffi_lib) $(lib_process)
ctypes-foreign-threaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-threaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-threaded.install_native_objects = no

ctypes-foreign-threaded: PROJECT=ctypes-foreign-threaded
ctypes-foreign-threaded: $$(LIB_TARGETS)

# ctypes-foreign-unthreaded subproject
ctypes-foreign-unthreaded.public = foreign
ctypes-foreign-unthreaded.install = yes
ctypes-foreign-unthreaded.threads = no
ctypes-foreign-unthreaded.dir = src/ctypes-foreign-unthreaded
ctypes-foreign-unthreaded.subproject_deps = ctypes ctypes-foreign-base
ctypes-foreign-unthreaded.link_flags = $(libffi_lib) $(lib_process)
ctypes-foreign-unthreaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-unthreaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign-unthreaded.install_native_objects = no

ctypes-foreign-unthreaded: PROJECT=ctypes-foreign-unthreaded
ctypes-foreign-unthreaded: $$(LIB_TARGETS)

# ctypes-top subproject
ctypes-top.public = ctypes_printers
ctypes-top.dir = src/ctypes-top
ctypes-top.install = yes
ctypes-top.deps = compiler-libs
ctypes-top.subproject_deps = ctypes
ctypes-top.install_native_objects = yes

ctypes-top: PROJECT=ctypes-top
ctypes-top: $$(LIB_TARGETS)

# configuration
configured: src/ctypes/ctypes_primitives.ml src/ctypes-foreign-base/libffi_abi.ml src/ctypes-foreign-base/dl.ml src/ctypes-foreign-base/dl_stubs.c

src/ctypes-foreign-base/dl.ml: src/ctypes-foreign-base/dl.ml$(OS_ALT_SUFFIX)
	cp $< $@
src/ctypes-foreign-base/dl_stubs.c: src/ctypes-foreign-base/dl_stubs.c$(OS_ALT_SUFFIX)
	cp $< $@

src/ctypes/ctypes_primitives.ml: src/configure/extract_from_c.ml src/configure/gen_c_primitives.ml
	$(HOSTOCAMLFIND) ocamlc -o gen_c_primitives -package str,bytes -linkpkg $^ -I src/configure
	./gen_c_primitives > $@ 2> gen_c_primitives.log || (rm $@ && cat gen_c_primitives.log || false)

src/ctypes-foreign-base/libffi_abi.ml: src/configure/extract_from_c.ml src/configure/gen_libffi_abi.ml
	$(HOSTOCAMLFIND) ocamlc -o gen_libffi_abi -package str,bytes -linkpkg $^ -I src/configure
	./gen_libffi_abi > $@ 2> gen_c_primitives.log || (rm $@ && cat gen_c_primitives.log || false)

libffi.config: src/discover/commands.mli src/discover/commands.ml src/discover/discover.ml
	$(HOSTOCAMLFIND) ocamlc -o discover -package str,bytes -linkpkg $^ -I src/discover
	./discover -ocamlc "$(OCAMLFIND) ocamlc" > $@ || (rm $@ && false)

asneeded.config:
	./src/discover/determine_as_needed_flags.sh >> $@

# dependencies
depend: configure
	$(OCAMLDEP) $(foreach project,$(PROJECTS),-I $($(project).dir)) \
            $(shell find src examples -name '*.mli' -o -name '*.ml') \
           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" > .depend

#installation
META-install:
	$(OCAMLFIND) install ctypes META CHANGES.md

install-%: PROJECT=$*
install-%:
	$(if $(filter yes,$($(PROJECT).install)),\
		$(OCAMLFIND) install -add ctypes -optional $^ \
                   $(LIB_TARGETS) $(LIB_TARGET_EXTRAS) \
                   $(INSTALL_MLIS) $(INSTALL_CMIS) \
                   $(INSTALL_CMTS) $(INSTALL_CMTIS) \
                   $(INSTALL_HEADERS) \
                   $(if $(filter yes,$($(PROJECT).install_native_objects)),$(NATIVE_OBJECTS)))

install: META-install $(PROJECTS:%=install-%)

uninstall:
	$(OCAMLFIND) remove ctypes

DOCFILES=$(foreach project,$(PROJECTS),\
           $(foreach mli,$($(project).public),\
            $($(project).dir)/$(mli).mli))
DOCFLAGS=$(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))
# Avoid passing duplicate interfaces to ocamldoc.
DOCFILES:=$(filter-out src/ctypes-foreign-threaded/foreign.mli,$(DOCFILES))

doc:
	ocamldoc -html $(DOCFLAGS) $(DOCFILES)


.PHONY: depend clean configure all install doc $(PROJECTS)

include .depend Makefile.rules Makefile.examples Makefile.tests
-include libffi.config
-include asneeded.config

ifeq ($(libffi_available),false)
test-libffi:
	@echo "The following required C libraries are missing: libffi."
	@echo "Please install them and retry. If they are installed in a non-standard location"
	@echo "or need special flags, set the environment variables <LIB>_CFLAGS and <LIB>_LIBS"
	@echo "accordingly and retry."
	@echo
	@echo " For example, if libffi is installed in /opt/local, you can type:"
	@echo
	@echo "   export LIBFFI_CFLAGS=-I/opt/local/include"
	@echo "   export LIBFFI_LIBS=-L/opt/local/lib"
	@exit 1
else:
test-libffi:
endif

=== tests/bench-micro/Makefile ===
.PHONY: build bench clean

CFLAGS=-Wall -O2

CTYPES_INCLUDE=`ocamlfind query ctypes`/..

BENCH_MICRO_STUBS=bench_micro_stubs.h bench_micro_lib.c bench_micro_stubs.c
BENCH_MICRO_GENERATED=bench_micro_generated_stubs.c bench_micro_generated.ml

build: bench_micro

bench: build
	LD_LIBRARY_PATH=. ./bench_micro -ascii -q 10 +time +cycles \
		-clear-columns -no-compactions -v -ci-absolute -all-values \
		-overheads -save > summary.txt
	ocaml process_summary.ml summary.txt
	gnuplot bench_micro.gnuplot
	gnuplot bench_micro_interpreted.gnuplot

libbench_micro.so: $(BENCH_MICRO_STUBS)
	gcc -o libbench_micro.so -shared -fPIC $(CFLAGS) bench_micro_stubs.c

bench_micro_gen: $(BENCH_MICRO_STUBS) bench_micro_bindings.ml bench_micro_gen.ml
	ocamlfind opt -o bench_micro_gen \
		-linkpkg -package ctypes.foreign,ctypes.stubs \
		bench_micro_lib.c bench_micro_stubs.c \
		bench_micro_bindings.ml bench_micro_gen.ml

bench_micro_generated.ml bench_micro_generated_stubs.c: bench_micro_gen
	./bench_micro_gen

bench_micro: $(BENCH_MICRO_STUBS) $(BENCH_MICRO_GENERATED) libbench_micro.so bench_micro_bindings.ml bench_micro.ml
	ocamlfind opt -o bench_micro $(patsubst %,-ccopt %,$(CFLAGS)) \
		-cclib -lbench_micro -cclib -L. \
		-thread -linkpkg -I $(CTYPES_INCLUDE) \
		-package ctypes.foreign,ctypes.stubs,core,core_bench \
		bench_micro_lib.c bench_micro_stubs.c \
		bench_micro_generated_stubs.c \
		bench_micro_bindings.ml bench_micro_generated.ml bench_micro.ml

clean:
	rm -f bench_micro bench_micro_gen libbench_micro.so
	rm -f bench_micro_generated.ml bench_micro_generated_stubs.c
	rm -f bench_micro.eps bench_micro_interpreted.eps
	rm -f *.o *.cmo *.cmx *.cmi

=== debian/changelog ===
ocaml-ctypes (0.7.0-1build2) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 17:06:43 +0200

ocaml-ctypes (0.7.0-1build1) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 14:39:06 +0100

ocaml-ctypes (0.7.0-1) unstable; urgency=medium

  * New upstream release
    - all patches have been merged upstream

 -- Stéphane Glondu <glondu@debian.org>  Mon, 01 Aug 2016 10:18:46 +0200

ocaml-ctypes (0.6.2-7) unstable; urgency=medium

  * Fix and re-enable test-roots
  * Fix typo in ctypes_primitive_ffitype

 -- Stéphane Glondu <glondu@debian.org>  Wed, 22 Jun 2016 15:44:15 +0200

ocaml-ctypes (0.6.2-6) unstable; urgency=medium

  * Add support for bytecode architectures
  * Temporarily disable root lifetime test (it fails on mipsel, let's
    debug bytecode support first)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 22 Jun 2016 12:04:40 +0200

ocaml-ctypes (0.6.2-5) unstable; urgency=medium

  * Add missing return in ffi_return_type_adjustment

 -- Stéphane Glondu <glondu@debian.org>  Wed, 22 Jun 2016 09:34:31 +0200

ocaml-ctypes (0.6.2-4) unstable; urgency=medium

  * Initialize the return slot for small return values from callbacks

 -- Stéphane Glondu <glondu@debian.org>  Tue, 21 Jun 2016 09:06:58 +0200

ocaml-ctypes (0.6.2-3) unstable; urgency=medium

  * Fix for PowerPC: handle libffi's integer return type promotion

 -- Stéphane Glondu <glondu@debian.org>  Sat, 18 Jun 2016 16:03:51 +0200

ocaml-ctypes (0.6.2-2) unstable; urgency=medium

  * Use the same C compiler as OCaml to build test stubs

 -- Stéphane Glondu <glondu@debian.org>  Wed, 15 Jun 2016 11:00:18 +0200

ocaml-ctypes (0.6.2-1) unstable; urgency=medium

  * New upstream release
    - add liblwt-ocaml-dev to Build-Depends
  * Bump Standards-Version to 3.9.8

 -- Stéphane Glondu <glondu@debian.org>  Tue, 14 Jun 2016 11:41:13 +0200

ocaml-ctypes (0.4.1-2) unstable; urgency=medium

  * Use $(CURDIR) instead of $(PWD) in Makefile.test. This fixes FTBFS
    on autobuilders.
  * Bump Standards-Version to 3.9.7
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Feb 2016 12:42:35 +0100

ocaml-ctypes (0.4.1-1) unstable; urgency=medium

  * New upstream release (Closes: #792657)
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Fri, 04 Dec 2015 11:11:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ocaml-ctypes
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper (>= 9),
@@ -9,10 +10,11 @@
  libounit-ocaml-dev,
  ocaml-findlib,
  ocaml-nox (>= 4.00.0),
+ liblwt-ocaml-dev,
  dh-ocaml
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-ctypes.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-ctypes.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
 Homepage: https://github.com/ocamllabs/ocaml-ctypes
 
 Package: libctypes-ocaml

=== debian/rules ===
--- 
+++ 
@@ -24,4 +24,4 @@
 
 .PHONY: override_dh_install
 override_dh_install:
-	dh_install --fail-missing -X.so.owner
+	dh_install --fail-missing -X.so.owner -XCHANGES.md

## ocaml-ctypes 0.15.1

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,12 @@
 .SECONDEXPANSION:
 
 BEST:=$(shell if ocamlopt > /dev/null 2>&1; then echo native; else echo byte; fi)
-DEBUG=false
+OPAQUE:=$(shell if ocamlopt -opaque 2>/dev/null; then echo -opaque; fi) 
+NO_KEEP_LOCS:=$(shell if ocamlopt -no-keep-locs 2>/dev/null; then echo -no-keep-locs; fi) 
+DEBUG=true
 COVERAGE=false
 OCAML=ocaml
-OCAMLFIND=ocamlfind
+OCAMLFIND=ocamlfind $(OCAMLFINDFLAGS)
 HOSTOCAMLFIND=$(OCAMLFIND)
 OCAMLDEP=$(OCAMLFIND) ocamldep
 OCAMLMKLIB=$(OCAMLFIND) ocamlmklib
@@ -14,12 +16,28 @@
 FOREIGN_PROJECTS=test-libffi ctypes-foreign-base ctypes-foreign-threaded ctypes-foreign-unthreaded
 STUB_PROJECTS=cstubs
 PROJECTS=$(BASE_PROJECTS) $(FOREIGN_PROJECTS) $(STUB_PROJECTS)
+DEP_DIRS=$(foreach project,$(PROJECTS),$($(project).dir))
 GENERATED=src/ctypes/ctypes_primitives.ml	\
           src/ctypes-foreign-base/libffi_abi.ml \
           src/ctypes-foreign-base/dl.ml		\
           src/ctypes-foreign-base/dl_stubs.c	\
           libffi.config				\
-          asneeded.config
+          asneeded.config                       \
+          discover				\
+          gen_c_primitives			\
+          gen_c_primitives.log			\
+          gen_libffi_abi			\
+	  src/configure/extract_from_c.cmi	\
+	  src/configure/extract_from_c.cmo	\
+	  src/configure/gen_c_primitives.cmi	\
+	  src/configure/gen_c_primitives.cmo	\
+	  src/configure/gen_libffi_abi.cmi	\
+	  src/configure/gen_libffi_abi.cmo	\
+	  src/discover/commands.cmi		\
+	  src/discover/commands.cmo		\
+	  src/discover/discover.cmi		\
+	  src/discover/discover.cmo
+
 OCAML_FFI_INCOPTS=$(libffi_opt)
 export CFLAGS DEBUG
 
@@ -39,15 +57,17 @@
 ctypes-foreign: ctypes-base $(FOREIGN_PROJECTS)
 ctypes-stubs: ctypes-base $(STUB_PROJECTS)
 
-clean:
+clean: clean-examples clean-tests
 	rm -fr _build
 	rm -f $(GENERATED)
 
 # ctypes subproject
-ctypes.public = ctypes_static ctypes_primitive_types unsigned signed ctypes_structs ctypes posixTypes ctypes_types
+ctypes.cmi_only = ctypes_static ctypes_primitive_types ctypes_structs cstubs_internals
+ctypes.public = lDouble complexL ctypes posixTypes ctypes_types
 ctypes.dir = src/ctypes
 ctypes.extra_mls = ctypes_primitives.ml
-ctypes.deps = str bigarray bytes
+ctypes.deps = bigarray bytes integers
+ctypes.linkdeps = integers_stubs
 ctypes.install = yes
 ctypes.install_native_objects = yes
 ifeq ($(XEN),enable)
@@ -58,11 +78,13 @@
 ctypes: $(ctypes.dir)/$(ctypes.extra_mls) $$(LIB_TARGETS)
 
 # cstubs subproject
-cstubs.public = cstubs_internals cstubs_structs cstubs cstubs_inverted
+cstubs.public = cstubs_structs cstubs cstubs_inverted
 cstubs.dir = src/cstubs
 cstubs.subproject_deps = ctypes
-cstubs.deps = str bytes
+cstubs.deps = str bytes integers
 cstubs.install = yes
+cstubs.install_native_objects = yes
+cstubs.extra_hs = $(package_integers_path)/ocaml_integers.h
 
 cstubs: PROJECT=cstubs
 cstubs: $(cstubs.dir)/$(cstubs.extra_mls) $$(LIB_TARGETS)
@@ -73,7 +95,7 @@
 ctypes-foreign-base.install_native_objects = yes
 ctypes-foreign-base.threads = no
 ctypes-foreign-base.dir = src/ctypes-foreign-base
-ctypes-foreign-base.deps = bytes
+ctypes-foreign-base.deps = bytes integers
 ctypes-foreign-base.subproject_deps = ctypes
 ctypes-foreign-base.extra_mls = libffi_abi.ml dl.ml
 ctypes-foreign-base.extra_cs = dl_stubs.c
@@ -93,6 +115,7 @@
 ctypes-foreign-threaded.link_flags = $(libffi_lib) $(lib_process)
 ctypes-foreign-threaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
 ctypes-foreign-threaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
+ctypes-foreign-threaded.cmi_opts = $(OPAQUE) $(NO_KEEP_LOCS)
 ctypes-foreign-threaded.install_native_objects = no
 
 ctypes-foreign-threaded: PROJECT=ctypes-foreign-threaded
@@ -107,6 +130,7 @@
 ctypes-foreign-unthreaded.link_flags = $(libffi_lib) $(lib_process)
 ctypes-foreign-unthreaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
 ctypes-foreign-unthreaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
+ctypes-foreign-unthreaded.cmi_opts = $(OPAQUE) $(NO_KEEP_LOCS)
 ctypes-foreign-unthreaded.install_native_objects = no
 
 ctypes-foreign-unthreaded: PROJECT=ctypes-foreign-unthreaded
@@ -116,7 +140,7 @@
 ctypes-top.public = ctypes_printers
 ctypes-top.dir = src/ctypes-top
 ctypes-top.install = yes
-ctypes-top.deps = compiler-libs
+ctypes-top.deps = compiler-libs integers
 ctypes-top.subproject_deps = ctypes
 ctypes-top.install_native_objects = yes
 
@@ -148,9 +172,9 @@
 
 # dependencies
 depend: configure
-	$(OCAMLDEP) $(foreach project,$(PROJECTS),-I $($(project).dir)) \
+	$(OCAMLDEP) -one-line $(foreach dir,$(DEP_DIRS),-I $(dir)) \
             $(shell find src examples -name '*.mli' -o -name '*.ml') \
-           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" > .depend
+           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" | sort > .depend
 
 #installation
 META-install:
@@ -174,7 +198,7 @@
 DOCFILES=$(foreach project,$(PROJECTS),\
            $(foreach mli,$($(project).public),\
             $($(project).dir)/$(mli).mli))
-DOCFLAGS=$(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))
+DOCFLAGS=-I $(shell ocamlfind query integers) $(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))
 # Avoid passing duplicate interfaces to ocamldoc.
 DOCFILES:=$(filter-out src/ctypes-foreign-threaded/foreign.mli,$(DOCFILES))
 
@@ -198,7 +222,7 @@
 	@echo " For example, if libffi is installed in /opt/local, you can type:"
 	@echo
 	@echo "   export LIBFFI_CFLAGS=-I/opt/local/include"
-	@echo "   export LIBFFI_LIBS=-L/opt/local/lib"
+	@echo "   export LIBFFI_LIBS=\"-L/opt/local/lib -lffi\""
 	@exit 1
 else:
 test-libffi:

=== debian/changelog ===
ocaml-ctypes (0.15.1-1build3) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:28:53 +0000

ocaml-ctypes (0.15.1-1build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:14:11 +0000

ocaml-ctypes (0.15.1-1build1) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 08:29:54 +0000

ocaml-ctypes (0.15.1-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.0

 -- Stéphane Glondu <glondu@debian.org>  Mon, 19 Aug 2019 13:12:22 +0200

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
 XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 12),
  libffi-dev,
- libounit-ocaml-dev,
  ocaml-findlib,
  ocaml-nox (>= 4.00.0),
- liblwt-ocaml-dev,
+ libintegers-ocaml-dev,
  dh-ocaml
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
+Standards-Version: 4.4.0
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
 Homepage: https://github.com/ocamllabs/ocaml-ctypes
 
 Package: libctypes-ocaml

=== debian/rules ===
--- 
+++ 
@@ -15,13 +15,15 @@
 export OCAMLFIND_LDCONF
 
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml --no-parallel
 
 .PHONY: override_dh_auto_install
 override_dh_auto_install:
 	mkdir -p $(OCAMLFIND_DESTDIR) $(DESTDIR)/$(OCAML_DLL_DIR)
 	dh_auto_install
 
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing -X.so.owner -XCHANGES.md
+override_dh_missing:
+	dh_missing --fail-missing -X.so.owner -XCHANGES.md
+
+override_dh_auto_test:
+# needs lwt >= 3.2.0

## ocaml-ctypes 0.17.1

=== debian/changelog ===
ocaml-ctypes (0.17.1-2build3) groovy; urgency=medium

  * No change rebuild against new ocaml ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Aug 2020 12:21:55 +0100

ocaml-ctypes (0.17.1-2build2) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 24 Aug 2020 20:12:14 +0100

ocaml-ctypes (0.17.1-2build1) groovy; urgency=medium

  * No change rebuild against new libffi ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Aug 2020 13:41:31 +0100

ocaml-ctypes (0.17.1-2) unstable; urgency=medium

  * Link libtest_functions.so with -lm (fixes FTBFS on some architectures)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 05 Aug 2020 17:29:30 +0200

ocaml-ctypes (0.17.1-1) unstable; urgency=medium

  * New upstream release
  * Enable upstream build-time tests
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Wed, 05 Aug 2020 13:01:22 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,16 @@
 XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  libffi-dev,
  ocaml-findlib,
- ocaml-nox (>= 4.00.0),
+ ocaml-nox,
  libintegers-ocaml-dev,
+ libounit-ocaml-dev,
+ liblwt-ocaml-dev (>= 3.2.0),
  dh-ocaml
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
 Homepage: https://github.com/ocamllabs/ocaml-ctypes

## ocaml-ctypes 0.20.0

=== debian/changelog ===
ocaml-ctypes (0.20.0-1build2) kinetic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 May 2022 15:54:27 +0200

ocaml-ctypes (0.20.0-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jan 2022 10:40:01 +0100

ocaml-ctypes (0.20.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 17 Dec 2021 15:46:57 +0100

ocaml-ctypes (0.19.1-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release
  * Bump Standards-Version to 4.6.0

  [ Helmut Grohne ]
  * Annotate test dependencies <!nocheck>. (Closes: #981784)

  [ Debian Janitor ]
  * Update watch file format version to 4
  * Set upstream metadata fields

 -- Stéphane Glondu <glondu@debian.org>  Sun, 28 Nov 2021 17:23:15 +0100

## ocaml-ctypes 0.20.1

=== Makefile ===
.SECONDEXPANSION:

BEST:=$(shell if ocamlopt > /dev/null 2>&1; then echo native; else echo byte; fi)
OPAQUE:=$(shell if ocamlopt -opaque 2>/dev/null; then echo -opaque; fi) 
NO_KEEP_LOCS:=$(shell if ocamlopt -no-keep-locs 2>/dev/null; then echo -no-keep-locs; fi) 
DEBUG=true
COVERAGE=false
OCAML=ocaml
OCAMLFIND=ocamlfind $(OCAMLFINDFLAGS)
HOSTOCAMLFIND=$(OCAMLFIND)
OCAMLDEP=$(OCAMLFIND) ocamldep
OCAMLMKLIB=$(OCAMLFIND) ocamlmklib
VPATH=src examples
BUILDDIR=_build
BASE_PROJECTS=configure libffi-abigen configured ctypes ctypes-top
FOREIGN_PROJECTS=test-libffi ctypes-foreign
STUB_PROJECTS=cstubs
PROJECTS=$(BASE_PROJECTS) $(FOREIGN_PROJECTS) $(STUB_PROJECTS)
DEP_DIRS=$(foreach project,$(PROJECTS),$($(project).dir))
GENERATED=src/ctypes/ctypes_primitives.ml	\
          src/ctypes-foreign/libffi_abi.ml \
          src/ctypes-foreign/dl.ml		\
          src/ctypes-foreign/dl_stubs.c	\
          libffi.config				\
          asneeded.config                       \
          discover				\
          gen_c_primitives			\
          gen_c_primitives.log			\
          gen_libffi_abi			\
	  src/configure/extract_from_c.cmi	\
	  src/configure/extract_from_c.cmo	\
	  src/configure/gen_c_primitives.cmi	\
	  src/configure/gen_c_primitives.cmo	\
	  src/configure/gen_libffi_abi.cmi	\
	  src/configure/gen_libffi_abi.cmo	\
	  src/discover/commands.cmi		\
	  src/discover/commands.cmo		\
	  src/discover/discover.cmi		\
	  src/discover/discover.cmo

OCAML_FFI_INCOPTS=$(libffi_opt)
export CFLAGS DEBUG

EXTDLL:=$(shell $(OCAMLFIND) ocamlc -config | awk '/^ext_dll:/{print $$2}')
OSYSTEM:=$(shell $(OCAMLFIND) ocamlc -config | awk '/^system:/{print $$2}')

ifneq (,$(filter mingw%,$(OSYSTEM)))
OS_ALT_SUFFIX=.win
else
OS_ALT_SUFFIX=.unix
endif

# public targets
all: libffi.config $(PROJECTS)

ctypes-base: $(BASE_PROJECTS)
ctypes-foreign: ctypes-base test-libffi
ctypes-stubs: ctypes-base $(STUB_PROJECTS)

clean: clean-examples clean-tests
	rm -fr _build
	rm -f $(GENERATED)

# ctypes subproject
ctypes.cmi_only = ctypes_static ctypes_primitive_types ctypes_structs cstubs_internals
ctypes.public = lDouble complexL ctypes posixTypes ctypes_types
ctypes.dir = src/ctypes
ctypes.extra_mls = ctypes_primitives.ml
ctypes.deps = bigarray-compat integers
ctypes.linkdeps = integers_stubs
ctypes.install = yes
ctypes.install_native_objects = yes
ifeq ($(XEN),enable)
ctypes.xen = yes
endif

ctypes: PROJECT=ctypes
ctypes: $(ctypes.dir)/$(ctypes.extra_mls) $$(LIB_TARGETS)

# cstubs subproject
cstubs.public = cstubs_structs cstubs cstubs_inverted
cstubs.dir = src/cstubs
cstubs.subproject_deps = ctypes
cstubs.deps = str integers
cstubs.install = yes
cstubs.install_native_objects = yes
cstubs.extra_hs = $(package_integers_path)/ocaml_integers.h

cstubs: PROJECT=cstubs
cstubs: $(cstubs.dir)/$(cstubs.extra_mls) $$(LIB_TARGETS)

# ctypes-foreign subproject
ctypes-foreign.public = dl libffi_abi foreign
ctypes-foreign.dir = src/ctypes-foreign
ctypes-foreign.subproject_deps = ctypes
ctypes-foreign.deps = integers
ctypes-foreign.install = yes
ctypes-foreign.install_native_objects = yes
ctypes-foreign.extra_cs = dl_stubs.c
ctypes-foreign.extra_mls = libffi_abi.ml dl.ml
ctypes-foreign.cmi_opts = $(OPAQUE) $(NO_KEEP_LOCS)
ctypes-foreign.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
ctypes-foreign.link_flags = $(libffi_lib) $(lib_process)
ctypes-foreign.threads = yes

ctypes-foreign: PROJECT=ctypes-foreign
ctypes-foreign: $$(LIB_TARGETS)

# ctypes-top subproject
ctypes-top.public = ctypes_printers
ctypes-top.dir = src/ctypes-top
ctypes-top.install = yes
ctypes-top.deps = compiler-libs integers
ctypes-top.subproject_deps = ctypes
ctypes-top.install_native_objects = yes

ctypes-top: PROJECT=ctypes-top
ctypes-top: $$(LIB_TARGETS)

# configuration
configured: src/ctypes/ctypes_primitives.ml src/ctypes-foreign/libffi_abi.ml src/ctypes-foreign/dl.ml src/ctypes-foreign/dl_stubs.c

src/ctypes-foreign/dl.ml: src/ctypes-foreign/dl.ml$(OS_ALT_SUFFIX)
	cp $< $@
src/ctypes-foreign/dl_stubs.c: src/ctypes-foreign/dl_stubs.c$(OS_ALT_SUFFIX)
	cp $< $@

src/ctypes/ctypes_primitives.ml: src/configure/extract_from_c.ml src/configure/gen_c_primitives.ml
	$(HOSTOCAMLFIND) ocamlc -o gen_c_primitives -package str -strict-sequence -linkpkg $^ -I src/configure
	./gen_c_primitives > $@ 2> gen_c_primitives.log || (rm $@ && cat gen_c_primitives.log || false)

src/ctypes-foreign/libffi_abi.ml: src/configure/extract_from_c.ml src/configure/gen_libffi_abi.ml
	$(HOSTOCAMLFIND) ocamlc -o gen_libffi_abi -package str -strict-sequence -linkpkg $^ -I src/configure
	./gen_libffi_abi > $@ 2> gen_c_primitives.log || (rm $@ && cat gen_c_primitives.log || false)

libffi.config: src/discover/commands.mli src/discover/commands.ml src/discover/discover.ml
	$(HOSTOCAMLFIND) ocamlc -o discover -package str -strict-sequence -linkpkg $^ -I src/discover
	./discover -ocamlc "$(OCAMLFIND) ocamlc" > $@ || (rm $@ && false)

asneeded.config:
	./src/discover/determine_as_needed_flags.sh >> $@

# dependencies
depend: configure
	$(OCAMLDEP) -one-line $(foreach dir,$(DEP_DIRS),-I $(dir)) \
            $(shell find src examples -name '*.mli' -o -name '*.ml') \
           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" | sort > .depend

#installation
META-install:
	$(OCAMLFIND) install ctypes META CHANGES.md

install-%: PROJECT=$*
install-%:
	$(if $(filter yes,$($(PROJECT).install)),\
		$(OCAMLFIND) install -add ctypes -optional $^ \
                   $(LIB_TARGETS) $(LIB_TARGET_EXTRAS) \
                   $(INSTALL_MLIS) $(INSTALL_CMIS) \
                   $(INSTALL_CMTS) $(INSTALL_CMTIS) \
                   $(INSTALL_HEADERS) \
                   $(if $(filter yes,$($(PROJECT).install_native_objects)),$(NATIVE_OBJECTS)))

install: META-install $(PROJECTS:%=install-%)

uninstall:
	$(OCAMLFIND) remove ctypes

DOCFILES=$(foreach project,$(PROJECTS),\
           $(foreach mli,$($(project).public),\
            $($(project).dir)/$(mli).mli))
DOCFLAGS=-I $(shell ocamlfind query integers) $(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))

doc:
	ocamldoc -html $(DOCFLAGS) $(DOCFILES)


.PHONY: depend clean configure all install doc $(PROJECTS)

include .depend Makefile.rules Makefile.examples Makefile.tests
-include libffi.config
-include asneeded.config

ifeq ($(libffi_available),false)
test-libffi:
	@echo "The following required C libraries are missing: libffi."
	@echo "Please install them and retry. If they are installed in a non-standard location"
	@echo "or need special flags, set the environment variables <LIB>_CFLAGS and <LIB>_LIBS"
	@echo "accordingly and retry."
	@echo
	@echo " For example, if libffi is installed in /opt/local, you can type:"
	@echo
	@echo "   export LIBFFI_CFLAGS=-I/opt/local/include"
	@echo "   export LIBFFI_LIBS=\"-L/opt/local/lib -lffi\""
	@exit 1
else:
test-libffi:
endif

=== examples/cstubs_structs/Makefile ===
all: main

# Step 1
bindings.cmx: bindings.ml
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -c bindings.ml

# Step 2
bindings_c_gen.cmx: bindings_c_gen.ml bindings.cmx
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -c bindings_c_gen.ml bindings.cmx

# Step 3 compiling
bindings_c_gen: bindings_c_gen.cmx bindings.cmx
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -linkpkg -o bindings_c_gen bindings.cmx bindings_c_gen.cmx

# Step 3 executing
bindings_stubs_gen.c: bindings_c_gen
	./bindings_c_gen

# Step 4 compiling
bindings_stubs_gen.o: bindings_stubs_gen.c
	ocamlfind ocamlc -w '@f@p@u@s@40' -package ctypes,ctypes.foreign -c bindings_stubs_gen.c

# Step 4 compiling
bindings_stubs_gen: bindings_stubs_gen.o
	cc -o bindings_stubs_gen bindings_stubs_gen.o

# Step 5
bindings_stubs.ml: bindings_stubs_gen
	./bindings_stubs_gen > bindings_stubs.ml

# Step 6
bindings_stubs.cmx: bindings_stubs.ml
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -c bindings_stubs.ml

# Use in the main program
main.cmx: bindings_stubs.cmx main.ml
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -c main.ml bindings_stubs.cmx

main: main.cmx
	ocamlfind ocamlopt -w '@f@p@u@s@40' -package ctypes,ctypes.foreign,ctypes.stubs -linkpkg -o main bindings.cmx bindings_stubs.cmx main.cmx

clean:
	-rm *.cmx *.cmi *.c *.o bindings_c_gen bindings_stubs_gen bindings_stubs.ml main

with_ocamlbuild:
	ocamlbuild -use-ocamlfind -package ctypes,ctypes.foreign,ctypes.stubs main.native

ocamlbuild_clean:
	ocamlbuild -clean

=== debian/changelog ===
ocaml-ctypes (0.20.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 21 Jan 2023 10:12:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: ocaml-ctypes
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  libffi-dev,
  ocaml-findlib,
  ocaml-nox,
+ libbigarray-compat-ocaml-dev,
  libintegers-ocaml-dev,
- libounit-ocaml-dev,
- liblwt-ocaml-dev (>= 3.2.0),
+ libounit-ocaml-dev <!nocheck>,
+ liblwt-ocaml-dev (>= 3.2.0) <!nocheck>,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes

=== debian/rules ===
--- 
+++ 
@@ -25,5 +25,4 @@
 override_dh_missing:
 	dh_missing --fail-missing -X.so.owner -XCHANGES.md
 
-override_dh_auto_test:
-# needs lwt >= 3.2.0
+override_dh_dwz:

=== debian/watch ===
version=4
https://github.com/ocamllabs/ocaml-ctypes/releases .*/(?:ocaml-ctypes-)?(.*)\.tar\.gz

## ocaml-ctypes 0.21.1

=== debian/changelog ===
ocaml-ctypes (0.21.1-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 16:04:43 +0100

ocaml-ctypes (0.21.1-1) unstable; urgency=medium

  * New upstream release
  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jul 2023 13:00:59 +0200

ocaml-ctypes (0.20.2-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2023 08:38:22 +0200

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/ocamllabs/ocaml-ctypes/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@

## ocaml-ctypes 0.22.0

=== debian/changelog ===
ocaml-ctypes (0.22.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Jun 2024 06:13:51 +0200

## ocaml-ctypes 0.23.0

=== debian/changelog ===
ocaml-ctypes (0.23.0-2) unstable; urgency=medium

  * Team upload.
  * Build ctypes-foreign
  * Add autopkgtests
  * Bump Standards-Version to 4.7.2 (no change)

 -- Kyle Robbertze <paddatrapper@debian.org>  Tue, 04 Nov 2025 17:06:05 +0000

ocaml-ctypes (0.23.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 29 Aug 2024 06:15:26 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,15 @@
 Build-Depends:
  debhelper-compat (= 13),
  libffi-dev,
- ocaml-findlib,
- ocaml-nox,
+ ocaml-dune,
+ libdune-ocaml-dev,
+ ocaml,
  libbigarray-compat-ocaml-dev,
  libintegers-ocaml-dev,
  libounit-ocaml-dev <!nocheck>,
  liblwt-ocaml-dev (>= 3.2.0) <!nocheck>,
- dh-ocaml
-Standards-Version: 4.6.0
+ dh-ocaml (>= 1.2)
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
@@ -39,6 +40,7 @@
 Package: libctypes-ocaml-dev
 Architecture: any
 Depends:
+ libffi-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}

=== debian/tests/control ===
Tests: upstream
Depends: ocaml-dune, libounit-ocaml-dev, libdune-ocaml-dev, liblwt-ocaml-dev, @
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/yallop/ocaml-ctypes/tags .*/v?(.*)\.tar\.gz

## ocaml-ctypes 0.24.0

=== debian/changelog ===
ocaml-ctypes (0.24.0-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Jan 2026 00:34:06 +0100

ocaml-ctypes (0.24.0-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 28 Nov 2025 09:31:01 +0100

=== debian/watch ===
Version: 5

Source: https://github.com/yallop/ocaml-ctypes/tags
Matching-Pattern: .*/v?(.*)\.tar\.gz
